Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1036354 - Review Request: nodejs-codemirror - A versatile JS text editor
Summary: Review Request: nodejs-codemirror - A versatile JS text editor
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Parag AN(पराग)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: nodejs-reviews
TreeView+ depends on / blocked
 
Reported: 2013-12-01 11:11 UTC by Mosaab Alzoubi
Modified: 2014-11-12 23:13 UTC (History)
4 users (show)

Fixed In Version: nodejs-codemirror-4.6.0-3.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-11-12 23:13:49 UTC
panemade: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Mosaab Alzoubi 2013-12-01 11:11:42 UTC
Spec URL: http://ojuba.org/oji/SPECS/nodejs-codemirror.spec
SRPM URL: http://ojuba.org/oji/SRPMS/nodejs-codemirror-3.20.0-1.oji.fc19.src.rpm
Description:
CodeMirror is a JavaScript component that provides a code editor in
the browser. When a mode is available for the language you are coding
in, it will color your code, and optionally help with indentation.

Fedora Account System Username: moceap

Comment 1 Ian Firns 2014-05-15 14:19:35 UTC
I currently have no sponsor and am very much in the learning phase. Please note  this is an informal preliminary review IAW the Packaging Review Guidelines [1].

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======

1. To build a package containing pure JavaScript node modules, you need to have BuildRequires: nodejs-packaging [2]

2. bin/authors.sh and some other scripts are missing shebangs. See rpmlint output below.

3. measure_scroll.txt looks like a small TODO/questions. It's certainly not documentation.

4. the doc folder is not included in the %doc directive

5. rpmlint has errors.




===== MUST =====

[!]:  rpmlint must be run on the source rpm and all binary rpms the build
      produces. The output should be posted in the review.

      Note: rpmlint has output and is attached below. rpmlint was run on both
      the src.rpm and resulting noarch.rpm packages.

[x]:  The package must be named according to the Package Naming Guidelines.

[x]:  The spec file name must match the base package %{name}, in the format
      %{name}.spec unless your package has an exemption.

[x]:  The package must meet the Packaging Guidelines.

[x]:  The package must be licensed with a Fedora approved license and meet the
      Licensing Guidelines.

[x]:  The License field in the package spec file must match the actual license.

[x]:  If (and only if) the source package includes the text of the license(s)
      in its own file, then that file, containing the text of the license(s)
      for the package must be included in %doc.

[x]:  The spec file must be written in American English.

[x]:  The spec file for the package MUST be legible.

[x]:  The sources used to build the package must match the upstream source, as
      provided in the spec URL. Reviewers should use sha256sum for this task as
      it is used by the sources file once imported into git. If no upstream URL
      can be specified for this package, please see the Source URL Guidelines
      for how to deal with this.

      Note: upstream is now at 4.1.0

[x]:  The package MUST successfully compile and build into binary rpms on at
      least one primary architecture.

[-]:  If the package does not successfully compile, build or work on an
      architecture, then those architectures should be listed in the spec in
      ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed
      in bugzilla, describing the reason that the package does not
      compile/build/work on that architecture. The bug number MUST be placed in
      a comment, next to the corresponding ExcludeArch line.

[x]:  All build dependencies must be listed in BuildRequires, except for any
      that are listed in the exceptions section of the Packaging Guidelines ;
      inclusion of those as BuildRequires is optional. Apply common sense.

[-]:  The spec file MUST handle locales properly. This is done by using the
      %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.

[-]:  Every binary RPM package (or subpackage) which stores shared library files
      (not just symlinks) in any of the dynamic linker's default paths, must
      call ldconfig in %post and %postun.

[x]:  Packages must NOT bundle copies of system libraries.

[-]:  If the package is designed to be relocatable, the packager must state this
      fact in the request for review, along with the rationalization for
      relocation of that specific package. Without this, use of Prefix: /usr is
      considered a blocker.

[x]:  A package must own all directories that it creates. If it does not create
      a directory that it uses, then it should require a package which does
      create that directory.

[x]:  A Fedora package must not list a file more than once in the spec file's
      %files listings. (Notable exception: license texts in specific
      %situations)

[x]:  Permissions on files must be set properly. Executables should be set with
      executable permissions, for example.

[x]:  Each package must consistently use macros.

[x]:  The package must contain code, or permissable content.

[x]:  Large documentation files must go in a -doc subpackage. (The definition of
      large is left up to the packager's best judgement, but is not restricted
      to size. Large can refer to either size or quantity).

      Note: Documentation size is 300k over 13 files.

[x]:  If a package includes something as %doc, it must not affect the runtime of
      the application. To summarize: If it is in %doc, the program must run
      properly if it is not present.

[-]:  Static libraries must be in a -static package.

[-]:  Development files must be in a -devel package.

[-]:  In the vast majority of cases, devel packages must require the base
      package using a fully versioned dependency: Requires: %{name}%{?_isa} =
      %{version}-%{release}

[x]:  Packages must NOT contain any .la libtool archives, these must be removed
      in the spec if they are built.

[-]:  Packages containing GUI applications must include a %{name}.desktop file,
      and that file must be properly installed with desktop-file-install in the
      %install section. If you feel that your packaged GUI application does not
      %need a .desktop file, you must put a comment in the spec file with your
      %explanation.

[x]:  Packages must not own files or directories already owned by other
      packages. The rule of thumb here is that the first package to be installed
      should own the files or directories that other packages may rely upon.
      This means, for example, that no package in Fedora should ever share
      ownership with any of the files or directories owned by the filesystem or
      man package. If you feel that you have a good reason to own a file or
      directory that another package owns, then please present that at package
      review time.

[x]:  All filenames in rpm packages must be valid UTF-8.


===== SHOULD =====

[x]:  If the source package does not include license text(s) as a separate file
      from upstream, the packager should query upstream to include it.

[-]:  The description and summary sections in the package spec file should
      contain translations for supported Non-English languages, if available

[x]:  The reviewer should test that the package builds in mock.

[x]:  The package should compile and build into binary rpms on all supported
      architectures.

      Note: Tested 32 bit and 64 bit (x86) only.

[?]:  The reviewer should test that the package functions as described. A
      package should not segfault instead of running, for example.

[-]:  If scriptlets are used, those scriptlets must be sane. This is vague, and
      left up to the reviewers judgement to determine sanity.

[-]:  Usually, subpackages other than devel should require the base package
      using a fully versioned dependency.

[-]:  The placement of pkgconfig(.pc) files depends on their usecase, and this
      is usually for development purposes, so should be placed in a -devel pkg.
      A reasonable exception is that the main pkg itself is a devel tool not
      installed in a user runtime, e.g. gcc or gdb.

[-]:  If the package has file dependencies outside of /etc, /bin, /sbin,
      /usr/bin, or /usr/sbin consider requiring the package which provides the
      file instead of the file itself.

[?]:  Your package should contain man pages for binaries/scripts. If it doesn't,
      work with upstream to add them where they make sense.



Rpmlint
-------

nodejs-codemirror.noarch: W: only-non-binary-in-usr-lib
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/mode/php/php.js
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/addon/hint/html-hint.js
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/mode/smartymixed/smartymixed.js
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/bin/authors.sh
nodejs-codemirror.src: W: strange-permission codemirror-3.20.0.tgz 0640L
2 packages and 0 specfiles checked; 4 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------

nodejs-codemirror.noarch: W: only-non-binary-in-usr-lib
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/mode/php/php.js
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/addon/hint/html-hint.js
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/mode/smartymixed/smartymixed.js
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/bin/authors.sh
1 packages and 0 specfiles checked; 4 errors, 1 warnings.


[1] https://fedoraproject.org/wiki/Packaging:ReviewGuidelines
[2] http://fedoraproject.org/wiki/Packaging:Node.js

Comment 3 Parag AN(पराग) 2014-10-21 09:05:07 UTC
Review:

+ package built fine in mock rawhide(x86_64)

- rpmlint on generated rpms gave output
nodejs-codemirror.noarch: W: incoherent-version-in-changelog 3.20.0-1 ['4.6.0-1.fc22', '4.6.0-1']
nodejs-codemirror.noarch: W: only-non-binary-in-usr-lib
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/mode/dylan/index.html
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/addon/hint/html-hint.js
nodejs-codemirror.noarch: E: script-without-shebang /usr/lib/node_modules/codemirror/bin/authors.sh
nodejs-codemirror.src: W: strange-permission codemirror-4.6.0.tgz 0640L
2 packages and 0 specfiles checked; 3 errors, 3 warnings.

+ Source verified with upstream as (sha256sum)
upstream tarball:c7d089b5ebec55fb9edbb05090f2ffc66b950018607fdc2c2d01678c483def87
srpm tarball:c7d089b5ebec55fb9edbb05090f2ffc66b950018607fdc2c2d01678c483def87

+ License is "MIT" and its text is included in LICENSE


Suggestions:
1) Fix the rpmlint message of changelog version and then manually change the tarball permission from 0640 to 664 and then create srpm. Also, shebang issues. See 

2) Group tag is optional and you may want to remove it for Fedora releases

3) change
BuildRequires:  nodejs-devel
to
BuildRequires:  nodejs-packaging

4)I don't think you need following in spec so remove it
%{?nodejs_find_provides_and_requires}

5) Its general practice to use in %prep
rm -rf node_modules

Please submit updated srpm for further package review. Also do read https://fedoraproject.org/wiki/Packaging:Node.js

Comment 4 Mosaab Alzoubi 2014-10-22 14:58:03 UTC
All Fixed , except sebangs. They aren't important in these places.


Spec: http://ojuba.org/test/nodejs-codemirror.spec
Srpm: http://ojuba.org/test/nodejs-codemirror-4.6.0-2.oj35.src.rpm

Comment 5 Parag AN(पराग) 2014-10-24 05:07:51 UTC
but its not that hard to fix shebang issues

just add following lines in the end of %prep section
chmod 644 mode/dylan/index.html addon/hint/html-hint.js
sed -i '1 i\#!/usr/bin/env bash ' bin/authors.sh

everything else looks good.

Comment 7 Parag AN(पराग) 2014-10-24 14:22:53 UTC
Looks good now :)

Package APPROVED.

Comment 8 Mosaab Alzoubi 2014-10-24 14:47:51 UTC
ThanX.

New Package SCM Request
=======================
Package Name: nodejs-codemirror
Short Description: A versatile JS text editor
Owners: moceap
Branches: f19 f20 f21 epel7

Comment 9 Gwyn Ciesla 2014-10-24 14:56:22 UTC
Git done (by process-git-requests).

Comment 10 Fedora Update System 2014-10-24 22:01:11 UTC
nodejs-codemirror-4.6.0-3.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/nodejs-codemirror-4.6.0-3.el7

Comment 11 Fedora Update System 2014-10-24 22:01:21 UTC
nodejs-codemirror-4.6.0-3.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/nodejs-codemirror-4.6.0-3.fc21

Comment 12 Fedora Update System 2014-10-24 22:01:30 UTC
nodejs-codemirror-4.6.0-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/nodejs-codemirror-4.6.0-3.fc20

Comment 13 Fedora Update System 2014-10-24 22:01:35 UTC
nodejs-codemirror-4.6.0-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/nodejs-codemirror-4.6.0-3.fc19

Comment 14 Fedora Update System 2014-10-28 11:03:01 UTC
nodejs-codemirror-4.6.0-3.el7 has been pushed to the Fedora EPEL 7 testing repository.

Comment 15 Fedora Update System 2014-11-01 16:44:19 UTC
nodejs-codemirror-4.6.0-3.fc21 has been pushed to the Fedora 21 stable repository.

Comment 16 Fedora Update System 2014-11-07 02:32:59 UTC
nodejs-codemirror-4.6.0-3.fc20 has been pushed to the Fedora 20 stable repository.

Comment 17 Fedora Update System 2014-11-07 02:34:45 UTC
nodejs-codemirror-4.6.0-3.fc19 has been pushed to the Fedora 19 stable repository.

Comment 18 Fedora Update System 2014-11-12 23:13:49 UTC
nodejs-codemirror-4.6.0-3.el7 has been pushed to the Fedora EPEL 7 stable repository.


Note You need to log in before you can comment on or make changes to this bug.